"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Transactional = void 0;
var wrap_in_transaction_1 = require("../transactions/wrap-in-transaction");
var Transactional = function (options) {
    return function (_, methodName, descriptor) {
        var originalMethod = descriptor.value;
        descriptor.value = (0, wrap_in_transaction_1.wrapInTransaction)(originalMethod, __assign(__assign({}, options), { name: methodName }));
        Reflect.getMetadataKeys(originalMethod).forEach(function (previousMetadataKey) {
            var previousMetadata = Reflect.getMetadata(previousMetadataKey, originalMethod);
            Reflect.defineMetadata(previousMetadataKey, previousMetadata, descriptor.value);
        });
        Object.defineProperty(descriptor.value, 'name', {
            value: originalMethod.name,
            writable: false,
        });
    };
};
exports.Transactional = Transactional;
//# sourceMappingURL=transactional.js.map