"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runOnTransactionComplete = exports.runOnTransactionRollback = exports.runOnTransactionCommit = exports.runInNewHookContext = exports.createEventEmitterInNewContext = exports.runAndTriggerHooks = exports.getTransactionalContextHook = void 0;
var events_1 = require("events");
var common_1 = require("../common");
var getTransactionalContextHook = function () {
    var context = (0, common_1.getTransactionalContext)();
    var emitter = (0, common_1.getHookInContext)(context);
    if (!emitter) {
        throw new Error('No hook manager found in context. Are you using @Transactional()?');
    }
    return emitter;
};
exports.getTransactionalContextHook = getTransactionalContextHook;
var runAndTriggerHooks = function (hook, cb) { return __awaiter(void 0, void 0, void 0, function () {
    var result, commitPromises_1, promiseCollector_1, commitPromise, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 3, , 4]);
                return [4 /*yield*/, Promise.resolve(cb())];
            case 1:
                result = _a.sent();
                commitPromises_1 = [];
                promiseCollector_1 = function (promise) {
                    commitPromises_1.push(promise);
                };
                commitPromise = new Promise(function (resolve, reject) {
                    setImmediate(function () {
                        // Emit the 'commit' event and collect promises
                        hook.emit('commit', promiseCollector_1);
                        // Once all handlers have been called, resolve the promise
                        Promise.all(commitPromises_1)
                            .then(function () { return resolve(); })
                            .catch(function (err) {
                            reject(err);
                        })
                            .finally(function () {
                            // Always clean up after commit handlers, regardless of success/failure
                            hook.emit('end', undefined);
                            hook.removeAllListeners();
                        });
                    });
                });
                // Wait for all commit handlers to complete
                return [4 /*yield*/, commitPromise];
            case 2:
                // Wait for all commit handlers to complete
                _a.sent();
                return [2 /*return*/, result];
            case 3:
                err_1 = _a.sent();
                setImmediate(function () {
                    hook.emit('rollback', err_1);
                    hook.emit('end', err_1);
                    hook.removeAllListeners();
                });
                throw err_1;
            case 4: return [2 /*return*/];
        }
    });
}); };
exports.runAndTriggerHooks = runAndTriggerHooks;
var createEventEmitterInNewContext = function () {
    var options = (0, common_1.getTransactionalOptions)();
    var emitter = new events_1.EventEmitter();
    emitter.setMaxListeners(options.maxHookHandlers);
    return emitter;
};
exports.createEventEmitterInNewContext = createEventEmitterInNewContext;
var runInNewHookContext = function (context, cb) { return __awaiter(void 0, void 0, void 0, function () {
    var hook;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                hook = (0, exports.createEventEmitterInNewContext)();
                return [4 /*yield*/, context.run(function () {
                        (0, common_1.setHookInContext)(context, hook);
                        return (0, exports.runAndTriggerHooks)(hook, cb);
                    })];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.runInNewHookContext = runInNewHookContext;
var runOnTransactionCommit = function (cb) {
    (0, exports.getTransactionalContextHook)().once('commit', function (promiseCollector) {
        var result = cb();
        // If the original callback returns a promise, we need to collect it
        if (result && typeof result.then === 'function') {
            promiseCollector(result);
        }
        return result;
    });
};
exports.runOnTransactionCommit = runOnTransactionCommit;
var runOnTransactionRollback = function (cb) {
    (0, exports.getTransactionalContextHook)().once('rollback', cb);
};
exports.runOnTransactionRollback = runOnTransactionRollback;
var runOnTransactionComplete = function (cb) {
    (0, exports.getTransactionalContextHook)().once('end', cb);
};
exports.runOnTransactionComplete = runOnTransactionComplete;
//# sourceMappingURL=index.js.map